/* bubble.c */
#include <stdio.h>

#define DIM		10

void bubble(int [], int);  /* prototipo di bubble */ 

int main(void)
{
	int i, num[DIM];
	FILE *fr = fopen("numeri.txt","r");
	FILE *fw = fopen("ordinati.txt","w");

	/* leggo DIM numeri dal file */
	for(i = 0; i < DIM; i++)
		fscanf(fr,"%d",&num[i]);

	/* li ordino con bubblesort */
	bubble(num,DIM);

	/* li stampo sul file */
	for(i = 0; i < DIM; i++)
		fprintf(fw,"%d ",num[i]);
	fprintf(fw,"\n");
}

/* bubble ordina i primi n elementi
   dell'array di interi a[],
   usando bubblesort.
*/
void bubble(int a[], int n)
{
	int i,j,tmp;

	for(i = 0; i < n - 1; i++)
		/* sistemo l'i-esimo elemento piu' piccolo */
		for(j = n - 1; j > i; j--)
			if(a[j-1] > a[j]) {
				/* scambio */
				tmp = a[j-1];
				a[j-1] = a[j];
				a[j] = tmp;	
			} 
}
