#include <stdio.h>

#define N	8

short matrix[N][N];

char checkpos(short x, short y)
{
	return !(x < 0 || x >= N || y < 0 || y >= N || matrix[x][y]); 
}

char backtrack(short x, short y, short n)
{
	short i,xx,yy;
	static short m[][2] = { 1,-2, 2,-1, 2,1, 1,2, -1,2, -2,1, -2,-1, -1,-2 };

	if(n == N * N)
		return 1;
	for(i = 0; i < 8; i++)
		if(checkpos(xx = x + m[i][0], yy = y + m[i][1])) {
			matrix[xx][yy] = n+1;
			if(backtrack(xx,yy,n+1))
				return 1;				
		}
	matrix[x][y] = 0;
	return 0; 
}

int main(void)
{
	short x,y,n;
	
	matrix[x = 0][y = 0] = n = 1;
	if(backtrack(x,y,1))
		for(y = 0; y < N; y++) {
			for(x = 0; x < N; x++)
				printf("[%2d]",matrix[x][y]);
			putchar('\n');
		}
}
