#include <stdio.h>
#include <stdlib.h> /* per il prototipo della funzione exit */

static void manageerror(char *s, short code)
{
	fprintf(stderr,"Errore: %s\n",s);
	exit(code);
}

#define SIZE	100

static int pos = 0;
static char stack[SIZE];

void push(char e)
{
	if(pos  < SIZE)
		stack[pos++] = e;
	else
		manageerror("Stack pieno",1);
}

char pop(void)
{
	if(pos)
		return stack[--pos];
	else {
		manageerror("Stack vuoto",2);
		return 0;
	}
}

char empty(void)
{
	return !pos;
}
