#include <stdio.h>
#include <stdlib.h>
#include "inttree.h"

void printtree(inttree *p);

void stampanodo(inttree *q)
{
	printf("[%2d]",q->dato);
}

int main(void)
{
	int a[] = { 5, 13, 12, 25, 6, 4, 12, 34, 13, 24, 11, 7, 9 };

	inttree *root = buildtree(a,0,13);
	
	printtree(root);

	printf("\nInorder:");
	inorder(root,stampanodo);
	printf("\nPreorder:");
	preorder(root,stampanodo);
	printf("\nPostorder:");
	postorder(root,stampanodo);
}
