#include <stdio.h>
#include <stdlib.h>

void useint(int i) { printf("Sto usando int:%d\n",i); }
void usechar(char c) { printf("Sto usando char:%c\n",c); }
void usedouble(double d) { printf("Sto usando double:%f\n",d); }
void useptr(int *p) { printf("Sto usando ptr:%p\n",(void *)p); }

struct elemento {
	char tipo;  /* 0: i, 1: c, 2: d, 3: p */
	union {
		int i;
		char c;
        	double d;
		int *p;
	} dato;
};

void f(struct elemento *e) {
    switch(e->tipo) {
    case 0: useint(e->dato.i); break;
    case 1: usechar(e->dato.c); break;
    case 2: usedouble(e->dato.d); break;
    case 3: useptr(e->dato.p); break;
    }
}

int main(void)
{
	struct elemento *e = malloc(sizeof(struct elemento));

	e->dato.c = '0';
	e->tipo = 1;
	f(e);
	e->tipo = 0;
	f(e);
	e->tipo = 2;
	f(e);
	e->tipo = 3;
	f(e);
}
