#include <stdio.h>
#include <stdlib.h>

struct inttree {
	int dato;
	struct inttree *left, *right;
};

typedef struct inttree inttree;

void inorder(inttree *, void (*)(inttree *));
void preorder(inttree *, void (*)(inttree *));
void postorder(inttree *, void (*)(inttree *));

int countnodes(inttree *);
int countlevels(inttree *);

inttree *buildtree(int *, int, int);

void preorderit(inttree *, void (*)(inttree *));
void levelorderit(inttree *,void (*)(inttree *));
