#include <stdio.h>
#include "intlist.h"

/* funzione alternativa per la stampa di un elemento */
void printelem2(intlist *p)
{
	printf("[%d]%s",p->dato, p->next ? "->" : "");
}

int main(void)
{
	int array[] = { 5, 23, 15, 26, 12, 12, 11, 55, 3, 0, 5, 4 };
	int i;

	intlist *p, *root2;
	intlist *root = createlist();
	
	void (*stampa)(intlist *) = printelem; /* funzione di stampa */

	for(i = 0; i < 12; i++) {
		root = insert(root,array[i]);
		traverse(root,stampa);
		printf("\n Numero elementi nella lista: %d\n",countlist(root));
		printf("\n----------------------------------\n");
	}
		
	p = geteleminlist(root, 23);
	root = delete(root,p);
	printf("Dopo la cancellazione di 23\n");
	traverse(root,stampa);
	printf("\n Numero elementi nella lista: %d\n",countlist(root));
	
	root2 = createlist();
	for(i = 0; i < 12; i++)
		root2 = insertinorder(root2,array[i]);
	printf("\nEcco la seconda lista\n");
	traverse(root2,stampa);
	root = listcat(root,root2);
	printf("\nDopo la concatenazione\n");
	traverse(root,stampa);
	printf("\n\nNumero elementi dopo la concatenazione: %d\n", countlist(root));
	
	destroylist(root);
	root = NULL;  /* dopo la distruzione root non e' automaticamente NULL */
	traverse(root,stampa);
	printf("\n\nNumero elementi dopo la distruzione: %d\n", countlist(root));
}
