#include <stdio.h>

void push(char);
char pop(void);
char empty(void);

/* controlla che c sia una parentesi */
char parentesi(char c)
{
	return	   c == '(' || c == ')'
			|| c == '[' || c == ']'
			|| c == '{' || c == '}';	
}

/* controlla che la parentesi c chiuda la parentesi d */
char chiude(char c, char d)
{
	switch(d) {
	case '(':
		return c == ')';
	case '[':
		return c == ']';
	case '{':
		return c == '}';
	default:
		return 0;
	}	
}

int main(void)
{
	int c;
	char d;

	printf("Immetti stringa:\n");
	while((c = getchar()) != EOF && c != ';') {
		if(!parentesi(c))
			continue;
		if(!empty())
			if(chiude(c,d = pop()))
				continue;
			else {
				push(d);
				push(c);
			}
		else
			push(c);
	}
	printf("%s\n", empty() ? "Corretto" : "Sbagliato");
}
