#include "rbtree.h"

void printtree(rbtree *);

void stampanodo(rbnode *q)
{
	printf("[%2d|%c]",q->v,q->c == red ? 'R' : 'B');
}

int main(void)
{
	int i;
	key a[] = { 4, 2, 6, 5, 8, 7, 9 };
	rbtree *tree = createrbtree();
	rbnode *p,*q;

	for(i = 0; i < 7; i++) {
		printf("\nInsert (%d):\t",a[i]);
		rbinsert(tree,a[i]);
		putchar('\n');
		printtree(tree);
		getchar();
	}

	printf("\n\nRicerca di:\t");
	scanf("%d",&i);
	if(p = search(tree,i)) {
		printf("\n Nodo %d trovato: %d.",i,p->v);
		if(q = treepred(tree,p))
			printf("\n Predecessore di %d:\t %d",p->v, q->v );
		if(q = treesucc(tree,p))
		printf("\n Successore di %d:\t %d",p->v, q->v );
 	}
	else
		printf("\n Nodo %d non trovato.",i);
	printf("\n Elemento minimo:\t %d", treemin(tree)->v );
	printf("\n Elemento massimo:\t %d", treemax(tree)->v );
	if(p) {
		printf("\n Dopo l'eliminazione di %d: \n", p->v );
		rbdelete(tree,p);
		printtree(tree);
	}
	putchar('\n');
}
