#include <stdio.h>

/* restituisce 1 se s e t sono uguali, 0 altrimenti */
char strequal(const char *s, const char *t)
{
	while(*t && *s++ == *t)
		t++;
	return !*t;
}

/* restituisce il puntatore alla prima occorrenza di t in s, o NULL se t non occorre in s */
char *strstr(char *s, const char *t)
{
	do {
		if(*s == *t)
			if(strequal(s,t))
				return s;	
	} while(*s++);
	return NULL;
}

/* restituisce la lunghezza della stringa s, senza contare il carattere di terminazione */
unsigned strlen(const char *s)
{
	register const char *t = s;

	while(*t++);
	return t-s-1;
}

int main(void)
{
	char s[80],t[80],*r;
	int pos;

	printf("Inserisci la prima parola:\n");
	scanf("%s",s);
	printf("Inserisci la parola da cercare in \"%s\":\n",s);
	scanf("%s",t);
	if((r = strstr(s,t))) {
		*(r + strlen(t)) = 0;
		pos = r - s;
		printf("La prima occorrenza della parola %s si trova in posizione %d\n",r,pos);
		/* Nota: provate a stampare s: cosa e' successo? */
	} else
		printf("La parola %s non occorre in %s\n",t,s);
	return 0;
}
